using System;
using System.Collections.Generic;
using System.Text;
using System.Configuration;
using System.Windows.Forms;

namespace SQLString.Classes
{
	public class SQLUserSettings : ApplicationSettingsBase
	{
		[UserScopedSetting()]
		[DefaultSettingValue("localhost")]
		public String DatabaseServer
		{
			get
			{
				return ( (String) this["DatabaseServer"] );
			}
			set
			{
				this["DatabaseServer"] = (String) value;
			}
		}

		[UserScopedSetting()]
		[DefaultSettingValue("SQLString")]
		public String DatabaseCatalog
		{
			get
			{
				return ( (String) this["DatabaseCatalog"] );
			}
			set
			{
				this["DatabaseCatalog"] = (String) value;
			}
		}

		[UserScopedSetting()]
		[DefaultSettingValue("UserID")]
		public String UserID
		{
			get
			{
				return ( (String) this["UserID"] );
			}
			set
			{
				this["UserID"] = (String) value;
			}
		}

		[UserScopedSetting()]
		[DefaultSettingValue("UserPassword")]
		public String UserPassword
		{
			get
			{
				return ( (String) this["UserPassword"] );
			}
			set
			{
				this["UserPassword"] = (String) value;
			}
		}

		[UserScopedSetting()]
		[DefaultSettingValue("Checked")]
		public CheckState IntegratedSecurity
		{
			get
			{
				return ( (CheckState) this["IntegratedSecurity"] );
			}
			set
			{
				this["IntegratedSecurity"] = (CheckState) value;
			}
		}
	}
}
